<template>
  <SwPluginSlot name="gs-add-to-cart-btn" :slot-context="{product, title, addToCartDisabled, isSmall, isHover}">
    <SwButton class="sw-gs-add-to-cart-btn"
              :class="{'is-circle': isSmall, 'is-hover': isHover}"
              :aria-label="`Add to Cart ${title}`"
              :disabled="addToCartDisabled"
              @click.stop="onAddToCart">
      <div v-if="isSmall" class="sw-gs-add-to-cart-btn--icons">
        <SwGsIconCart class="color-white size-sm"/>
      </div>
      <template v-else>
        {{ $t('Add to cart') }}
      </template>
    </SwButton>
  </SwPluginSlot>
</template>

<script lang="ts">
  import SwButton from "@/components/atoms/SwButton.vue"
  import { SwGsIconCart } from "./icons";
  import { useAppointment } from "../logic/composables/useAppointment";
  import { useGsCart } from "../logic/composables/useGsCart";
  import SwPluginSlot from "sw-plugins/SwPluginSlot.vue"

  export default {
    name: "SwGsAddToCartBtn",
    components: {
      SwButton,
      SwGsIconCart,
      SwPluginSlot
    },
    props: {
      product: {
        type: Object,
        default: () => ({}),
      },
      title: {
        type: String,
        default: "",
      },
      addToCartDisabled: {
        type: Boolean,
        default: false,
      },
      isSmall: {
        type: Boolean,
        default: true
      },
      isHover: {
        type: Boolean,
        default: true
      }
    },
    setup(props, {}) {
      const product = props.product;
      const { isGuide } = useAppointment();
      const { addProducts } = useGsCart();

      function onAddToCart(event) {
        event.preventDefault();
        addProducts([{
          id: product.id,
        }]);
      }

      return {
        onAddToCart,
        isGuide
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .sw-gs-add-to-cart-btn {
    --button-box-shadow: 0px 4px 11px rgba(29, 31, 34, 0.1);
    --button-size: 46px;
    width: 100%;
    display: block;
    padding: 10px;

    &.is-circle {
      width: var(--button-size);
    }

    &.is-hover {
      --product-card-add-button-right: var(--spacer-2xs);
      transform: var(--product-card-add-button-transform, translate3d(0, 50%, 0));
      opacity: var(--product-card-add-button-opacity, 0);
      display: var(--product-card-add-button-display, none);
      position: absolute;
      right: var(--product-card-add-button-right, 1rem);
      bottom: var(--product-card-add-button-bottom, 0);
      z-index: var(--helper-lay-over-sibling-z-index);

      &:focus {
        --product-card-add-button-opacity: 1;
      }
    }

  }
</style>
